#define POWER_VIA_PORT_C2_C3 1 // use port pins port C2 and C3 as power supply of the Nunchuck (direct plug using wiichuck adapter)
#define USE_NEW_WAY_INIT 1 // use "The New Way" of initialization <http://wiibrew.org/wiki/Wiimote#The_New_Way>
#define WII_IDENT_LEN ((byte)6)
#define WII_TELEGRAM_LEN ((byte)6)
#define WII_NUNCHUCK_TWI_ADR ((byte)0x52)
#include <Wire.h>
#include <string.h>
#include <utility/twi.h>
#include <Servo.h> 
Servo myservo1;  // create servo object to control a servo 
Servo myservo2;  // create servo object to control a servo 
#undef int
#include <stdio.h>
uint8_t outbuf[WII_TELEGRAM_LEN]; // array to store arduino output
int cnt = 0;
int ledPinC = 3;
int ledPinZ = 4;
int servoPin1 = 7;
int servoPin2 = 8;
int locCx = 122; //moves to location when c button pressed
int locCy =  42;
int locZx = 178; //moves to location when z button pressed
int locZy =  77;
int ledPinD = 9;
int ledPinL = 10;
int ledPinU = 11;
int ledPinR = 12;
int ledPin = 13;
int servoPos1 = 90;
int servoPos2 = 90;
int pulseWidth = 0;
int pulseWidth2 = 0;
long lastPulse = 0;
long lastPulse2 = 0;
int refreshTime = 20;
int minPulse = 1000;
int minPulse2 = 500;
int dtime=10;
#define pwbuffsize 10
long pwbuff[pwbuffsize];
long pwbuffpos = 0;
long pwbuff2[pwbuffsize];
long pwbuffpos2 = 0;

void setup (){
  Serial.begin (19200);
  #ifdef POWER_VIA_PORT_C2_C3 // power supply of the Nunchuck via port C2 and C3
    PORTC &=~ _BV(PORTC2);
    PORTC |= _BV(PORTC3);
    DDRC |= _BV(PORTC2) | _BV(PORTC3); // make outputs
    delay(100); // wait for things to stabilize
  #endif
  Wire.begin(); // initialize i2c
  #define TWI_FREQ_NUNCHUCK 400000L
  TWBR = ((CPU_FREQ / TWI_FREQ_NUNCHUCK) - 16) / 2;
  nunchuck_init(0); // send the initialization handshake
  pinMode(ledPinC, OUTPUT);      
  pinMode(ledPinZ, OUTPUT);      
  pinMode(servoPin1, OUTPUT);      
  pinMode(servoPin2, OUTPUT);      
  pinMode(ledPinU, OUTPUT);      
  pinMode(ledPinD, OUTPUT);      
  pinMode(ledPinL, OUTPUT);      
  pinMode(ledPinR, OUTPUT);      
  pinMode(ledPin, OUTPUT);      
  pulseWidth = minPulse;
  pulseWidth2 = minPulse2;
  byte i;
  if(readControllerIdent(outbuf) == 0){
    Serial.print("Ident=");
    for (i = 0; i < WII_TELEGRAM_LEN; i++){
      Serial.print(outbuf[i], HEX);
      Serial.print(' ');
    }
    Serial.println();
  }
  myservo1.attach(servoPin1);  // attaches the servo on pin 6 to the servo object 
  myservo2.attach(servoPin2);  // attaches the servo on pin 7 to the servo object 
  Serial.println("Finished setup");
}

byte nunchuck_init (unsigned short timeout){
  byte rc = 1;
  #ifndef USE_NEW_WAY_INIT
    Wire.beginTransmission (WII_NUNCHUCK_TWI_ADR); // transmit to device 0x52
    Wire.send (0x40); // sends memory address
    Wire.send (0x00); // sends sent a zero.
    Wire.endTransmission (); // stop transmitting
  #else
    unsigned long time = millis();
    do{
      Wire.beginTransmission (WII_NUNCHUCK_TWI_ADR); // transmit to device 0x52
      Wire.send (0xF0); // sends memory address
      Wire.send (0x55); // sends data.
      if(Wire.endTransmission() == 0){ // stop transmitting
        Wire.beginTransmission (WII_NUNCHUCK_TWI_ADR); // transmit to device 0x52
        Wire.send (0xFB); // sends memory address
        Wire.send (0x00); // sends sent a zero.
        if(Wire.endTransmission () == 0){ // stop transmitting
          rc = 0;
        }
      }
    }
    while (rc != 0 && (!timeout || ((millis() - time) < timeout)));
  #endif
  return rc;
}

byte readControllerIdent(byte* pIdent){
  byte rc = 1;
  Wire.beginTransmission (WII_NUNCHUCK_TWI_ADR); // transmit to device 0x52
  Wire.send (0xFA); // sends memory address of ident in controller
  if(Wire.endTransmission () == 0){ // stop transmitting
    byte i;
    Wire.requestFrom (WII_NUNCHUCK_TWI_ADR, WII_TELEGRAM_LEN); // request data from nunchuck
    for (i = 0; (i < WII_TELEGRAM_LEN) && Wire.available (); i++){
      pIdent[i] = Wire.receive(); // receive byte as an integer
    }
    if(i == WII_TELEGRAM_LEN){
      rc = 0;
    }
  }
  return rc;
}

void clearTwiInputBuffer(void){
  while( Wire.available ())
  Wire.receive ();
}

void send_zero (){
  for(byte i = 0; i < 3; i++){
    Wire.beginTransmission (WII_NUNCHUCK_TWI_ADR); // transmit to device 0x52
    Wire.send (0x00); // sends one byte
    Wire.endTransmission (); // stop transmitting
  }
}

int t = 0;
void loop (){
  t++;
  long last = millis();
//
  if( t == 1) {
    t = 0;
//
  Wire.requestFrom (WII_NUNCHUCK_TWI_ADR, WII_TELEGRAM_LEN); // request data from nunchuck
  for (cnt = 0; (cnt < WII_TELEGRAM_LEN) && Wire.available (); cnt++){
    outbuf[cnt] = nunchuk_decode_byte (Wire.receive ()); // receive byte as an integer
    digitalWrite (ledPin, HIGH); // sets the LED on
  }
  clearTwiInputBuffer();
  if (cnt >= WII_TELEGRAM_LEN){  // If we recieved the 6 bytes, then go print them
    print ();
//
            int z_button = 0;
            int c_button = 0;

            if ((outbuf[5] >> 0) & 1) 
                z_button = 1;
            if ((outbuf[5] >> 1) & 1)
                c_button = 1;

            switch (c_button) {
              case 1:
                switch (z_button) {
                  case 1:
                    muovi();
                    digitalWrite (ledPinC, LOW);
                    digitalWrite (ledPinZ, LOW);
                  break;
                  case 0:
                    digitalWrite (ledPinC, LOW);
                    digitalWrite (ledPinZ, HIGH);
                  break;
                }
              break;
              case 0:
                switch (z_button) {
                  case 1:
                    digitalWrite (ledPinC, HIGH);
                    digitalWrite (ledPinZ, LOW);
                  break;
                  case 0:
                    digitalWrite (ledPinC, HIGH);
                    digitalWrite (ledPinZ, HIGH);
                  break;
                }
              break;
            }
//
  }
  send_zero (); // send the request for next bytes

//
  }
  updateServo();
//
  delay (20);
}

void print (){
  int joy_x_axis = outbuf[0];
  int joy_y_axis = outbuf[1];
  int accel_x_axis = outbuf[2];// * 2 * 2
  int accel_y_axis = outbuf[3];// * 2 * 2
  int accel_z_axis = outbuf[4];// * 2 * 2
  int z_button = 0;
  int c_button = 0;

  if (accel_x_axis < 120){
    digitalWrite (ledPinL, HIGH);
    digitalWrite (ledPinR, LOW);
  }
  if (accel_x_axis > 130){
    digitalWrite (ledPinR, HIGH);
    digitalWrite (ledPinL, LOW);
  }
  if (accel_x_axis > 120 && accel_x_axis < 130){
    digitalWrite (ledPinR, LOW);
    digitalWrite (ledPinL, LOW);
  }
  if (accel_y_axis < 130){
    digitalWrite (ledPinD, HIGH);
    digitalWrite (ledPinU, LOW);
  }
  if (accel_y_axis > 140){
    digitalWrite (ledPinU, HIGH);
    digitalWrite (ledPinD, LOW);
  }
  if (accel_y_axis > 130 && accel_y_axis < 140){
    digitalWrite (ledPinU, LOW);
    digitalWrite (ledPinD, LOW);
  }
  if (
    (accel_x_axis > 120) &&
    (accel_x_axis < 130) &&
    (accel_y_axis > 130) &&
    (accel_y_axis < 140)
  ){
    digitalWrite (ledPinR, HIGH);
    digitalWrite (ledPinL, HIGH);
    digitalWrite (ledPinU, HIGH);
    digitalWrite (ledPinD, HIGH);
  }

  if ((outbuf[5] >> 0) & 1){ z_button = 1; }
  if ((outbuf[5] >> 1) & 1){ c_button = 1; }
/*
  if ((outbuf[5] >> 2) & 1){ accel_x_axis += 2; }
  if ((outbuf[5] >> 3) & 1){ accel_x_axis += 1; }
  if ((outbuf[5] >> 4) & 1){ accel_y_axis += 2; }
  if ((outbuf[5] >> 5) & 1){ accel_y_axis += 1; }
  if ((outbuf[5] >> 6) & 1){ accel_z_axis += 2; }
  if ((outbuf[5] >> 7) & 1){ accel_z_axis += 1; }
*/

  if (c_button){
    digitalWrite (ledPinC, LOW);
  } else {
    digitalWrite (ledPinC, HIGH);
    servoPos1=locCx;                  // sets the servo position according to the scaled value 
    servoPos2=locCy;                  // sets the servo position according to the scaled value 
    myservo1.write(servoPos1);                  // sets the servo position according to the scaled value 
    myservo2.write(servoPos2);                  // sets the servo position according to the scaled value 
    delay(500);                           // waits for the servo to get there 
  }
  if (z_button){
    digitalWrite (ledPinZ, LOW);
  } else {
    digitalWrite (ledPinZ, HIGH);
    servoPos1=locZx;                  // sets the servo position according to the scaled value 
    servoPos2=locZy;                  // sets the servo position according to the scaled value 
    myservo1.write(servoPos1);                  // sets the servo position according to the scaled value 
    myservo2.write(servoPos2);                  // sets the servo position according to the scaled value 
    delay(500);                           // waits for the servo to get there 
  }

Serial.print (joy_x_axis, DEC);
Serial.print ("\t");
Serial.print (joy_y_axis, DEC);
Serial.print ("\t");
Serial.print (accel_x_axis, DEC);
Serial.print ("\t");
Serial.print (accel_y_axis, DEC);
Serial.print ("\t");
Serial.print (accel_z_axis, DEC);
Serial.print ("\t");
Serial.print (z_button, DEC);
Serial.print ("\t");
Serial.print (c_button, DEC);
Serial.print ("\t");
Serial.print ("\r\n");

  if(!c_button && !z_button){ } else {
    // if(!c_button){ delay(1000); }
    // if(!z_button){ delay(5000); }
  }
  if(
    (joy_x_axis == 255) && 
    (joy_y_axis == 255) && 
    (accel_x_axis == 255) && 
    (accel_y_axis == 255) && 
    (accel_z_axis == 255) && 
    (joy_x_axis == 1) && 
    (joy_x_axis == 1)
  ){ setup(); }
}

char nunchuk_decode_byte (char x){
  #ifndef USE_NEW_WAY_INIT
    x = (x ^ 0x17) + 0x17;
  #endif
  return x;
}

void muovi (){
  float serv1 = outbuf[0];// joy x 0-255 
  if (serv1 < 200 && serv1 > 50){
    // centered
  } else if (serv1 > 250){
    servoPos1=servoPos1-5;
  } else if (serv1 > 200){
    servoPos1=servoPos1-2;
  } else if (serv1 < 5){
    servoPos1=servoPos1+5;
  } else if (serv1 < 50){
    servoPos1=servoPos1+2;
  }
    
  float serv2 = outbuf[1];// joy y 0-255
  if (serv2 < 200 && serv2 > 50){
    // centered
  } else if (serv2 > 250){
    servoPos2=servoPos2+5;
  } else if (serv2 > 200){
    servoPos2=servoPos2+2;
  } else if (serv2 < 5){
    servoPos2=servoPos2-5;
  } else if (serv2 < 50){
    servoPos2=servoPos2-2;
  }
  if (servoPos1 < 0){ servoPos1 = 0; }
  if (servoPos1 > 179){ servoPos1 = 179; }
  if (servoPos2 < 0){ servoPos2 = 0; }
  if (servoPos2 > 179){ servoPos2 = 179; }

Serial.print (servoPos1, DEC);
Serial.print ("\t");
Serial.print (servoPos2, DEC);
Serial.print ("\t");
Serial.print ("\r\n");
  //servoPos1 = map(serv1, 0, 255, 179, 0);// scale it to use it with the servo (value between 0 and 180) 
  //servoPos2 = map(serv2, 0, 255, 0, 179);// scale it to use it with the servo (value between 0 and 180) 
}

void updateServo() {
  myservo1.write(servoPos1);                  // sets the servo position according to the scaled value 
  myservo2.write(servoPos2);                  // sets the servo position according to the scaled value 
  delay(250);                           // waits for the servo to get there 
}

/*
void updateServo() {

    if (millis() - lastPulse >= refreshTime) {

        digitalWrite(servoPin, HIGH);
        delayMicroseconds(pulseWidth);
        digitalWrite(servoPin, LOW);

        digitalWrite(servoPin2, HIGH);
        delayMicroseconds(pulseWidth2);
        digitalWrite(servoPin2, LOW);

        lastPulse = millis();
    }
}

void muovi (){
    float tilt = (700 - outbuf[1]*2); // outbuf[3]
    float tilt2 = outbuf[0]*2; // outbuf[2]

    tilt = (tilt);
    pulseWidth = (tilt * 5) + minPulse;

    tilt2 = (tilt2-288);
    pulseWidth2 = (tilt2 * 5) + minPulse2;

    pwbuff[pwbuffpos] = pulseWidth;
    pwbuff2[pwbuffpos2] = pulseWidth2;
    
    if( ++pwbuffpos == pwbuffsize ) pwbuffpos = 0;
    if( ++pwbuffpos2 == pwbuffsize ) pwbuffpos2 = 0;


    pulseWidth=0;
    pulseWidth2=0;

    for( int p=0; p<pwbuffsize; p++ ){
        pulseWidth += pwbuff[p];
        pulseWidth2 += pwbuff2[p];
    }

    pulseWidth /= pwbuffsize;
    pulseWidth2 /= pwbuffsize;

}
*/
