int servoPin1 = 4;  // x
int servoPin2 = 3;  // y
int laserPin = 17;
int delayOn = 500;  // microSeconds
int x1 = 110;       // top left
int x2 = 80;        // bottom right
int y1 = 60;        // top left
int y2 = 90;        // bottom right

int servoPos1 = x1;
int servoPos2 = y1;
boolean laserOn = true;  // master off switch
boolean down = true;     // current direction starting from top
boolean right = true;    // current direction starting from left
#include <string.h>
#include <Servo.h> 
#include <stdio.h>
Servo myservo1;  // create servo object to control a servo 
Servo myservo2;  // create servo object to control a servo 

void setup (){
  Serial.begin (115200);  // zoomZoom
  pinMode(servoPin1, OUTPUT);      
  pinMode(servoPin2, OUTPUT);      
  pinMode(laserPin, OUTPUT);      
  myservo1.attach(servoPin1);
  myservo2.attach(servoPin2);
  digitalWrite (laserPin, HIGH); // sets the laser on
  Serial.println("Finished setup");
}

void loop (){
    muovi();                  // decide where to go
    updateServo();            // move there
    if(laserOn){ laser (); }  // check if laserMasterSwitch is on
}

void muovi (){
  if((servoPos1 == x1) && (servoPos2 == y1)){
    servoPos1--;
    down = true;
    right = true;
  } else if((servoPos1 == x2) && (servoPos2 == y2)){
    servoPos2--;
    down = false;
  } else if(down && right && (servoPos1 == x2)){
    right = false;
    servoPos2++;servoPos2++;
  } else if(down && !right && (servoPos1 == x1)){
    right = true;
    servoPos2--;
  } else if(!down && right && (servoPos1 == x2)){
    right = false;
    servoPos2--;servoPos2--;
  } else if(!down && !right && (servoPos1 == x1)){
    right = true;
    servoPos2++;
  } else if(right){
    servoPos1--;
  } else {
    servoPos1++;
  }
      
  if (servoPos1 < x2){ servoPos1 = x2; }
  if (servoPos1 > x1){ servoPos1 = x1; }
  if (servoPos2 < y1){ servoPos2 = y1; }
  if (servoPos2 > y2){ servoPos2 = y2; }

//  debug...
//  Serial.print (servoPos1, DEC);
//  Serial.print ("\t");
//  Serial.println (servoPos2, DEC);
}

void updateServo() {
  myservo1.write(servoPos1);                  // sets the servo position according to the scaled value 
  myservo2.write(servoPos2);                  // sets the servo position according to the scaled value 
}

void laser (){

  digitalWrite(laserPin, HIGH);   // sets the laser on
  delayMicroseconds(delayOn);
  digitalWrite(laserPin, LOW);    // sets the laser off
  delayMicroseconds(delayOn);
}
