/*  PS2Keyboard library example
  
  PS2Keyboard now requries both pins specified for begin()

  keyboard.begin(data_pin, irq_pin);
  
  Valid irq pins:
     Arduino:      2, 3
     Arduino Mega: 2, 3, 18, 19, 20, 21
     Teensy 1.0:   0, 1, 2, 3, 4, 6, 7, 16
     Teensy 2.0:   5, 6, 7, 8
     Teensy++ 1.0: 0, 1, 2, 3, 18, 19, 36, 37
     Teensy++ 2.0: 0, 1, 2, 3, 18, 19, 36, 37
     Sanguino:     2, 10, 11
  
  for more information you can read the original wiki in arduino.cc
  at http://www.arduino.cc/playground/Main/PS2Keyboard
  or http://www.pjrc.com/teensy/td_libs_PS2Keyboard.html
  
  Like the Original library and example this is under LGPL license.
  
  Modified by Cuninganreset@gmail.com on 2010-03-22
  Modified by Paul Stoffregen <paul@pjrc.com> June 2010
*/
   
#include <PS2Keyboard.h>
#include <LiquidCrystal.h>

const int DataPin = 4;
const int IRQpin =  3;
char output;
String out0 = "                ";
String out1 = "                ";
String out2 = "                ";
char out3;
char out4;
char out5;
char out6;
char out7;
char out8;
char out9;
int row;
int x;
int y;

PS2Keyboard keyboard;
LiquidCrystal lcd(7, 8, 9, 10, 11, 12);

void setup() {
  delay(1000);
  keyboard.begin(DataPin, IRQpin);
  lcd.begin(16, 2);
  Serial.begin(115200);
  Serial.println("Keyboard Test:");
  lcd.print("Your momma!");
  x = 0;
  y = 1;
  row = 0;
}

void loop() {
  if (keyboard.available()) {
    boolean more = false;
    boolean less = false;
    // read the next key
    char c = keyboard.read();
    // check for some of the special keys
    if (c == PS2_ENTER) {
      for(int i=0;i<16;i++){
         lcd.setCursor(i, y);
         lcd.print(' ');
      }
      x=0;
      lcd.setCursor(x, y);
      output = '\r\n';
      printing = false;
    } else if (c == PS2_TAB) {
      output = '\t';
      printing = false;
//    } else if (c == PS2_ESC) {
//      output = '[ESC]';
//    } else if (c == PS2_PAGEDOWN) {
//      y = ((y+1) == 2) ? 0 : 1; //pgDown
//    } else if (c == PS2_PAGEUP) {
//      output = '[PgUp]'; //pgUp
    } else if (c == PS2_LEFTARROW) {
      x = ((x-1) <0) ? 15 : x-1;
      lcd.setCursor(x, y);
      printing = false;
    } else if (c == PS2_RIGHTARROW) {
      x = ((x+1) == 16) ? 0 : x+1;
      lcd.setCursor(x, y);
      printing = false;
    } else if (c == PS2_UPARROW) {
      y = ((y-1) < 0) ? 1 : 0;
      lcd.setCursor(x, y);
      printing = false;
    } else if (c == PS2_DOWNARROW) {
      y = ((y+1) == 2) ? 0 : 1;
      lcd.setCursor(x, y);
      printing = false;
    } else if (c == PS2_BACKSPACE) {
      x = ((x-1) <0) ? 15 : x-1;
      lcd.setCursor(x, y);
      lcd.print(' ');
      printing = false;
//    } else if (c == PS2_DELETE) {
//      x = ((x-1) <0) ? 15 : x-1;
//      lcd.setCursor(x, y);
//      lcd.print(' ');
//      printing = false;
    } else {
      
      // otherwise, just print all normal characters
      output = c;
    }
    
    Serial.print(output);

    if(printing){
      String tempS;
      switch (row){
        case 0:
          tempS = out0;
        break;
        case 1:
          tempS = out1;
        break;
        case 2:
          tempS = out2;
        break;
      }
      if(more){ }
      if(less){ }
      tempS.setCharAt(x, output) 
      switch (row){
        case 0:
          out0 = tempS;
        break;
        case 1:
          out1 = tempS;
        break;
        case 2:
          out2 = tempS;
        break;
      }
      
      // set the cursor to column 0, line 1
      // (note: line 1 is the second row, since counting begins with 0):
      lcd.setCursor(0, y);
      lcd.print(tempS);
      x = ((x+1) == 16) ? 0 : x+1; //next
    }
    delay(100);
  }
}
