/*
     ,---.   ,--.  ,--.   ,---.   ,--. ,--. ,------.  ,---.  
    '   .-'  |  ,'.|  |  /  O  \  |  .'   / |  .---' '   .-' 
    `.  `-.  |  |' '  | |  .-.  | |  .   '  |  `--,  `.  `-. 
    .-'    | |  | `   | |  | |  | |  |\   \ |  `---. .-'    |
    `-----'  `--'  `--' `--' `--' `--' '--' `------' `-----' 

    A two-player game for the Wayne and Layne Video Game Shield.

Wayne and Layne, LLC
http://wayneandlayne.com

18/12/2010


   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/

#include <nunchuck.h>
#include <TVout.h>
#include <video_gen.h>
#include <VideoGameHelper.h>
#include "snake.h"
#include <fontALL.h>
#include <avr/pgmspace.h>
#include <i2cmaster.h>

TVout TV;
Nunchuck player1;
Nunchuck player2;

Snake snakes[5]; // struct defined in external header file

long round_num = 0;

#define EDGE 3
#define BAR_HEIGHT 8
#define CHAR_BAR_HEIGHT 6

#define SNAKES_ON_A_PLANE 0
#define SNAKES_ON_A_SPHERE 1
#define SNAKES_ON_A_TORUS 2

unsigned char game_mode = SNAKES_ON_A_SPHERE;
int scores[2] = {0, 0};
int changeP;
int xOffset = 0;
int yOffset = 0;
void setup()
{
  Serial.begin(115200);
  int tvError = TV.begin(_NTSC, 128, 96);
  Serial.println(tvError);
  TV.select_font(font4x6);
 
  title_screen_init_nunchucks(&TV, "Pac This ......", &player1, &player2, false);

  //rules_screen();
}
void showPac(){
  TV.draw_line(snakes[0].x+3, snakes[0].y+1, snakes[0].x+5, snakes[0].y+1, 1);
  TV.draw_line(snakes[0].x+2, snakes[0].y+2, snakes[0].x+6, snakes[0].y+2, 1);
  TV.draw_line(snakes[0].x+1, snakes[0].y+3, snakes[0].x+7, snakes[0].y+3, 1);
  TV.draw_line(snakes[0].x+1, snakes[0].y+4, snakes[0].x+7, snakes[0].y+4, 1);
  TV.draw_line(snakes[0].x+1, snakes[0].y+5, snakes[0].x+7, snakes[0].y+5, 1);
  TV.draw_line(snakes[0].x+2, snakes[0].y+6, snakes[0].x+6, snakes[0].y+6, 1);
  TV.draw_line(snakes[0].x+3, snakes[0].y+7, snakes[0].x+5, snakes[0].y+7, 1);
}
void blinkPac(){
  switch(snakes[0].d){
    case 0:
    TV.draw_line(snakes[0].x+5, snakes[0].y+3, snakes[0].x+7, snakes[0].y+3, 0);
    TV.draw_line(snakes[0].x+4, snakes[0].y+4, snakes[0].x+7, snakes[0].y+4, 0);
    TV.draw_line(snakes[0].x+5, snakes[0].y+5, snakes[0].x+7, snakes[0].y+5, 0);
    break;
    case 1:
    TV.draw_line(snakes[0].x+3, snakes[0].y+5, snakes[0].x+3, snakes[0].y+7, 0);
    TV.draw_line(snakes[0].x+4, snakes[0].y+4, snakes[0].x+4, snakes[0].y+7, 0);
    TV.draw_line(snakes[0].x+5, snakes[0].y+5, snakes[0].x+5, snakes[0].y+7, 0);
    break;
    case 2:
    TV.draw_line(snakes[0].x+1, snakes[0].y+3, snakes[0].x+3, snakes[0].y+3, 0);
    TV.draw_line(snakes[0].x+1, snakes[0].y+4, snakes[0].x+4, snakes[0].y+4, 0);
    TV.draw_line(snakes[0].x+1, snakes[0].y+5, snakes[0].x+3, snakes[0].y+5, 0);
    break;
    case 3:
    TV.draw_line(snakes[0].x+3, snakes[0].y+1, snakes[0].x+3, snakes[0].y+3, 0);
    TV.draw_line(snakes[0].x+4, snakes[0].y+1, snakes[0].x+4, snakes[0].y+4, 0);
    TV.draw_line(snakes[0].x+5, snakes[0].y+1, snakes[0].x+5, snakes[0].y+3, 0);
    break;
  }
}
void hidePac(){
  TV.draw_line(snakes[0].x+3, snakes[0].y+1, snakes[0].x+5, snakes[0].y+1, 0);
  TV.draw_line(snakes[0].x+2, snakes[0].y+2, snakes[0].x+6, snakes[0].y+2, 0);
  TV.draw_line(snakes[0].x+1, snakes[0].y+3, snakes[0].x+7, snakes[0].y+3, 0);
  TV.draw_line(snakes[0].x+1, snakes[0].y+4, snakes[0].x+7, snakes[0].y+4, 0);
  TV.draw_line(snakes[0].x+1, snakes[0].y+5, snakes[0].x+7, snakes[0].y+5, 0);
  TV.draw_line(snakes[0].x+2, snakes[0].y+6, snakes[0].x+6, snakes[0].y+6, 0);
  TV.draw_line(snakes[0].x+3, snakes[0].y+7, snakes[0].x+5, snakes[0].y+7, 0);
}
void put(){
  showPac();
  showGhosts();
  TV.delay_frame(5);
  blinkPac();
  blinkGhosts();
  TV.delay_frame(10);
  hidePac();
  hideGhosts();
}
void showGhosts(){
  for(int g=1;g<5;g++){
    TV.draw_line(snakes[g].x+3, snakes[g].y+1, snakes[g].x+5, snakes[g].y+1, 1);
    TV.draw_line(snakes[g].x+2, snakes[g].y+2, snakes[g].x+6, snakes[g].y+2, 1);
    TV.draw_line(snakes[g].x+1, snakes[g].y+3, snakes[g].x+7, snakes[g].y+3, 1);
    TV.draw_line(snakes[g].x+1, snakes[g].y+4, snakes[g].x+7, snakes[g].y+4, 1);
    TV.draw_line(snakes[g].x+1, snakes[g].y+5, snakes[g].x+7, snakes[g].y+5, 1);
    TV.draw_line(snakes[g].x+1, snakes[g].y+6, snakes[g].x+7, snakes[g].y+6, 1);
    switch(g){
      case 4:
        TV.set_pixel(snakes[g].x+7, snakes[g].y+7, 1);
      case 3:
        TV.set_pixel(snakes[g].x+5, snakes[g].y+7, 1);
      case 2:
        TV.set_pixel(snakes[g].x+3, snakes[g].y+7, 1);
      case 1:
        TV.set_pixel(snakes[g].x+1, snakes[g].y+7, 1);
      break;
    }
  }
}
void blinkGhosts(){
  for(int g=1;g<5;g++){
    switch(snakes[g].d){
      case 0:
        TV.set_pixel(snakes[g].x+4, snakes[g].y+3, 0);
        TV.set_pixel(snakes[g].x+6, snakes[g].y+3, 0);
      break;
      case 1:
        TV.set_pixel(snakes[g].x+3, snakes[g].y+4, 0);
        TV.set_pixel(snakes[g].x+5, snakes[g].y+4, 0);
      break;
      case 2:
        TV.set_pixel(snakes[g].x+2, snakes[g].y+3, 0);
        TV.set_pixel(snakes[g].x+4, snakes[g].y+3, 0);
      break;
      case 3:
        TV.set_pixel(snakes[g].x+3, snakes[g].y+2, 0);
        TV.set_pixel(snakes[g].x+5, snakes[g].y+2, 0);
      break;
    }
  }
}
void hideGhosts(){
  for(int g=1;g<5;g++){
    TV.draw_line(snakes[g].x+3, snakes[g].y+1, snakes[g].x+5, snakes[g].y+1, 0);
    TV.draw_line(snakes[g].x+2, snakes[g].y+2, snakes[g].x+6, snakes[g].y+2, 0);
    TV.draw_line(snakes[g].x+1, snakes[g].y+3, snakes[g].x+7, snakes[g].y+3, 0);
    TV.draw_line(snakes[g].x+1, snakes[g].y+4, snakes[g].x+7, snakes[g].y+4, 0);
    TV.draw_line(snakes[g].x+1, snakes[g].y+5, snakes[g].x+7, snakes[g].y+5, 0);
    TV.draw_line(snakes[g].x+1, snakes[g].y+6, snakes[g].x+7, snakes[g].y+6, 0);
    TV.set_pixel(snakes[g].x+1, snakes[g].y+7, 0);
    TV.set_pixel(snakes[g].x+3, snakes[g].y+7, 0);
    TV.set_pixel(snakes[g].x+5, snakes[g].y+7, 0);
    TV.set_pixel(snakes[g].x+7, snakes[g].y+7, 0);
  }
}

void rules_screen()
{
  TV.clear_screen();
  
  TV.printPGM(0, 0, PSTR("Available Maps:"));
  TV.draw_line(0, 10, TV.hres()-1, 10, 1);
  
  TV.draw_line(0, 15, 16, 15, 1); // top
  TV.draw_line(0, 25, 16, 25, 1); // bottom
  TV.draw_line(0, 15, 0, 25, 1); // left
  TV.draw_line(16, 15, 16, 25, 1); // right
  TV.printPGM(26, 18, PSTR("Plane"));
  
  TV.draw_line(0, 35, 16, 35, 1); // top
  TV.draw_line(0, 45, 16, 45, 1); // bottom
  TV.draw_line(0, 40, 5, 40, 1); // left arrow mid
  TV.draw_line(0, 40, 2, 38, 1); // left arrow upper diag
  TV.draw_line(0, 40, 2, 42, 1); // left arrow lower diag
  TV.draw_line(16, 40, 11, 40, 1); // right arrow mid
  TV.draw_line(16, 40, 14, 38, 1); // right arrow upper diag
  TV.draw_line(16, 40, 14, 42, 1); // right arrow lower diag
  TV.printPGM(26, 38, PSTR("Sphere"));
  
  TV.draw_line(8, 54, 8, 58, 1); // up arrow mid
  TV.draw_line(8, 54, 10, 56, 1); // up arrow right diag
  TV.draw_line(8, 54, 6, 56, 1); // up arrow left diag
  TV.draw_line(8, 66, 8, 62, 1); // down arrow mid
  TV.draw_line(8, 66, 10, 64, 1); // down arrow right diag
  TV.draw_line(8, 66, 6, 64, 1); //down arrow left diag
  TV.draw_line(0, 60, 5, 60, 1); // left arrow mid
  TV.draw_line(0, 60, 2, 58, 1); // left arrow upper diag
  TV.draw_line(0, 60, 2, 62, 1); // left arrow lower diag
  TV.draw_line(16, 60, 11, 60, 1); // right arrow mid
  TV.draw_line(16, 60, 14, 58, 1); // right arrow upper diag
  TV.draw_line(16, 60, 14, 62, 1); // right arrow lower diag
  TV.printPGM(26, 58, PSTR("Torus"));
  
  TV.draw_line(0, 75, TV.hres()-1, 75, 1);
  TV.printPGM(0, 80, PSTR("P1 press C"));
  
  TV.delay_frame(30);
  while(1)
  {
    player1.update();
    if (player1.button_c())
      break;
  }
  TV.delay_frame(30);
}

void ready_screen(){
  draw_score_bar();
  TV.printPGM(0, 0, PSTR("Press C when ready"));
  TV.printPGM(24, 32, PSTR("P1 ready?"));
  boolean p1_ready = false;
  while (! (p1_ready) ){
    delay(10);
    player1.update();
    if (player1.button_c()){
      p1_ready = true;
      TV.print(40, 40  , "ok");
    }
  }
  
  TV.print(TV.hres()/2-8, 50, "3...");
  TV.delay_frame(60);
  TV.print(TV.hres()/2-8, 60, "2...");
  TV.delay_frame(60);
  TV.print(TV.hres()/2-8, 70, "1...");
  TV.delay_frame(30);
}

boolean isNotWall(int x, int y){
    for(int h=0;h<9;h++){
      for(int w=0;w<9;w++){
        if(TV.get_pixel(x+w,y+h)){
          if((x+w+5)%10==0 && (y+h+5)%10==0){
            TV.tone(2000,50);
            scores[0]++;
            int printScore = scores[0];
            int place = 1;
            for(int i=0;i<sizeof(printScore);i++){
              int t = printScore/(10*(sizeof(printScore)-1));
              TV.print_char( place*8+xOffset, TV.vres()-1-EDGE-CHAR_BAR_HEIGHT, t);
              place++;
            }
//            Serial.print(x);Serial.print(" ");Serial.print(y);Serial.println(" dot");
            return true;
          }else{
//            Serial.print(x);Serial.print(" ");Serial.print(y);Serial.println(" wall");
            return false;
          }
        }
      }
    }
//    Serial.print(x);Serial.print(" ");Serial.print(y);Serial.println(" no wall");
    return true;
}
char move(){
  int newX,newY; //new location if not a wall or a ghost
  for(int i=0;i<5;i++){
    newX = (snakes[i].x + snakes[i].dir_x);
    newY = (snakes[i].y + snakes[i].dir_y);
    if(isNotWall(newX,newY)){
      snakes[i].x = newX;
      snakes[i].y = newY;
    }
  }
  for(int g=1;g<5;g++){ //touch a ghost
    if(snakes[g].x==snakes[0].x && snakes[g].y==snakes[0].y){
      return 1;
    }
  }
  put();
  return 0;
}

void loop(){
  TV.clear_screen();
  scores[0] = 0;
  scores[1] = 0;
  char* options[] = {"New", "Load", "Save"};
  game_mode = question_box(&TV, &player1, "Choose one...", options, 3, 0);
  TV.delay_frame(30);
  //char* speed_options[] = {"Fastest", "Fast", "Medium", "Slow", "Slower", "Snail's pace"};
  //int throttle = question_box(&TV, &player1, "Which speed?", speed_options, 6, 2);
  int throttle = 2;

  while (scores[0] < 1000000){ //get to this and you win
    TV.clear_screen();
    ready_screen();
    initialize_game();
    byte game_over = 0;
    long next_frame;

    while (!game_over) 
    {
      next_frame = display.frames+throttle; 
      round_num++;

      player1.update();

      // these functions update snake.dir_x and snake.dir_y:
      handle_pac();
      handle_ghosts();

      game_over = move();
      if (game_over)
      {
        TV.tone(1000,50);
        scores[game_over-1] += 1;
      }
      
      while (display.frames < next_frame) {};
    }
  }
  
  // winner winner chicken dinner
  TV.clear_screen();
  if (scores[0] == 10)
    TV.printPGM(0, 10, PSTR("Pac wins!"));
  else
    TV.printPGM(0, 10, PSTR("Ghost wins!"));
  TV.delay_frame(120);
}

void handle_pac()
{
  int debug = 0;
  int r;
  Nunchuck* n = snakes[0].nunchuck;
  changeP++;
  if(changeP > 10){
    if(debug){
      r = random(1,8);
    }else{
      r=0;
    }
  }
  if (n->joy_right() || r==4)// && ( snake->dir_x != -1 && snake->dir_y != 0))
  {
    snakes[0].dir_x = 1;
    snakes[0].dir_y = 0;
    snakes[0].d = 0;
    changeP = 0;
  } 
  else if (n->joy_left() || r==5)// && ( snake->dir_x != 1 && snake->dir_y != 0))
  {
    snakes[0].dir_x = -1;
    snakes[0].dir_y = 0;
    snakes[0].d = 2;
    changeP = 0;
  } 
  else if (n->joy_up() || r==2)// && ( snake->dir_x != 0 && snake->dir_y != 1)) 
  {
    snakes[0].dir_x = 0;
    snakes[0].dir_y = -1;
    snakes[0].d = 3;
    changeP = 0;
  } 
  else if (n->joy_down() || r==7)// && ( snake->dir_x != 0 && snake->dir_y != -1))
  {
    snakes[0].dir_x = 0;
    snakes[0].dir_y = 1;
    snakes[0].d = 1;
    changeP = 0;
  }
}
void handle_ghosts(){
  for(int g=1;g<5;g++){
    int r = random(1,8);
    if (r==4){
      snakes[g].dir_x = 1;
      snakes[g].dir_y = 0;
      snakes[g].d = 0;
    }else if (r==5){
      snakes[g].dir_x = -1;
      snakes[g].dir_y = 0;
      snakes[g].d = 2;
    }else if (r==2){
      snakes[g].dir_x = 0;
      snakes[g].dir_y = -1;
      snakes[g].d = 3;
    }else if (r==7){
      snakes[g].dir_x = 0;
      snakes[g].dir_y = 1;
      snakes[g].d = 1;
    }
  }
}

void print_whole_number(byte x, byte y, int number)
{
  char output[10];
  itoa(number, output, 10);
  TV.print(x, y, output);
}

void initialize_game()
{
  TV.clear_screen();
  draw_map(0);
  draw_score_bar();

  snakes[0].d = 0;
  snakes[0].x = 51+xOffset;
  snakes[0].y = 61+yOffset;
  snakes[0].dir_x = 1;
  snakes[0].dir_y = 0;
  snakes[0].nunchuck=&player1;
  
  snakes[1].d = 0;
  snakes[1].x = 41+xOffset;
  snakes[1].y = 31+yOffset;
  snakes[1].dir_x = 1;
  snakes[1].dir_y = 0;
  snakes[1].nunchuck=&player2;
  
  snakes[2].d = 2;
  snakes[2].x = 71+xOffset;
  snakes[2].y = 31+yOffset;
  snakes[2].dir_x = -1;
  snakes[2].dir_y = 0;
  snakes[2].nunchuck=&player2;
  
  snakes[3].d = 0;
  snakes[3].x = 41+xOffset;
  snakes[3].y = 41+yOffset;
  snakes[3].dir_x = 1;
  snakes[3].dir_y = 0;
  snakes[3].nunchuck=&player2;
  
  snakes[4].d = 2;
  snakes[4].x = 71+xOffset;
  snakes[4].y = 41+yOffset;
  snakes[4].dir_x = -1;
  snakes[4].dir_y = 0;
  snakes[4].nunchuck=&player2;
  round_num = 0;
}

void draw_score_bar()
{
//  TV.draw_rect(0, 84, 128, 12, 0, 0); //blank it first to 'refresh'
  TV.draw_line(0+xOffset, TV.vres()-EDGE-1-BAR_HEIGHT, 120+xOffset, TV.vres()-EDGE-1-BAR_HEIGHT, 1); //separator
  
  TV.print_char( 8+xOffset, TV.vres()-1-EDGE-CHAR_BAR_HEIGHT, '0'+scores[0]);//TODO: fix x value
  //TV.print_char(80+xOffset, TV.vres()-1-EDGE-CHAR_BAR_HEIGHT, 'L ' + scores[1]);//TODO: fix x value
  
  if (game_mode == SNAKES_ON_A_PLANE)
  {
    TV.print(24+xOffset, TV.vres()-1-EDGE-CHAR_BAR_HEIGHT, "Pac this."); //TODO: make this actually centered
  } 
  else if (game_mode == SNAKES_ON_A_SPHERE)
  {
    TV.print(24+xOffset, TV.vres()-1-EDGE-CHAR_BAR_HEIGHT, "Pac this.."); //TODO: make this actually centered
  }  
  else if (game_mode == SNAKES_ON_A_TORUS)
  {
    TV.print(24+xOffset, TV.vres()-1-EDGE-CHAR_BAR_HEIGHT, "Pac this..."); //TODO: make this actually centered    
  }
}

void draw_field()
{
  switch (game_mode)
  {
    case SNAKES_ON_A_PLANE:
      TV.draw_line(TV.hres()-EDGE-1,EDGE,TV.hres()-EDGE-1,TV.vres()-EDGE-1,1); //right
      TV.draw_line(EDGE,TV.vres()-EDGE-1, EDGE,EDGE,1); //left
      // yes, we want to fall-through here
    case SNAKES_ON_A_SPHERE:
      TV.draw_line(EDGE,EDGE,TV.hres()-EDGE-1,EDGE,1); //top
      TV.draw_line(EDGE, TV.vres()-EDGE-1,TV.hres()-EDGE-1,TV.vres()-EDGE-1,1); //bottom
      break;
  }
}
void draw_map(int m){
  switch(m){
    case 0:
      TV.draw_rect(  0+xOffset,  0+yOffset,120+xOffset, 80+yOffset,1);
      TV.draw_line( 60+xOffset,  0+yOffset, 60+xOffset, 10+yOffset,1);   
      TV.draw_line( 10+xOffset, 10+yOffset, 50+xOffset, 10+yOffset,1);   
      TV.draw_line( 70+xOffset, 10+yOffset,110+xOffset, 10+yOffset,1);   
      TV.draw_line( 10+xOffset, 10+yOffset, 10+xOffset, 20+yOffset,1);   
      TV.draw_line(110+xOffset, 10+yOffset,110+xOffset, 20+yOffset,1);   
      TV.draw_line( 20+xOffset, 20+yOffset, 40+xOffset, 20+yOffset,1);   
      TV.draw_line( 50+xOffset, 20+yOffset, 70+xOffset, 20+yOffset,1);   
      TV.draw_line( 80+xOffset, 20+yOffset,100+xOffset, 20+yOffset,1);   
      TV.draw_line( 20+xOffset, 20+yOffset, 20+xOffset, 30+yOffset,1);   
      TV.draw_line(100+xOffset, 20+yOffset,100+xOffset, 30+yOffset,1);   
      TV.draw_line( 10+xOffset, 30+yOffset, 20+xOffset, 30+yOffset,1);   
      TV.draw_line( 40+xOffset, 30+yOffset, 50+xOffset, 30+yOffset,1);   
      TV.draw_line( 60+xOffset, 30+yOffset, 80+xOffset, 30+yOffset,1);   
      TV.draw_line(100+xOffset, 30+yOffset,110+xOffset, 30+yOffset,1);   
      TV.draw_line( 30+xOffset, 30+yOffset, 30+xOffset, 50+yOffset,1);   
      TV.draw_line( 40+xOffset, 30+yOffset, 40+xOffset, 50+yOffset,1);   
      TV.draw_line( 80+xOffset, 30+yOffset, 80+xOffset, 50+yOffset,1);   
      TV.draw_line( 90+xOffset, 30+yOffset, 90+xOffset, 50+yOffset,1);   
      TV.draw_line(  0+xOffset, 40+yOffset, 30+xOffset, 40+yOffset,1);   
      TV.draw_line( 90+xOffset, 40+yOffset,120+xOffset, 40+yOffset,1);   
      TV.draw_line( 10+xOffset, 50+yOffset, 20+xOffset, 50+yOffset,1);   
      TV.draw_line( 40+xOffset, 50+yOffset, 60+xOffset, 50+yOffset,1);   
      TV.draw_line( 70+xOffset, 50+yOffset, 80+xOffset, 50+yOffset,1);   
      TV.draw_line(100+xOffset, 50+yOffset,110+xOffset, 50+yOffset,1);   
      TV.draw_line( 20+xOffset, 50+yOffset, 20+xOffset, 60+yOffset,1);   
      TV.draw_line(100+xOffset, 50+yOffset,100+xOffset, 60+yOffset,1);   
      TV.draw_line( 20+xOffset, 60+yOffset, 40+xOffset, 60+yOffset,1);   
      TV.draw_line( 50+xOffset, 60+yOffset, 70+xOffset, 60+yOffset,1);   
      TV.draw_line( 80+xOffset, 60+yOffset,100+xOffset, 60+yOffset,1);   
      TV.draw_line( 10+xOffset, 60+yOffset, 10+xOffset, 70+yOffset,1);   
      TV.draw_line(110+xOffset, 60+yOffset,110+xOffset, 70+yOffset,1);   
      TV.draw_line( 10+xOffset, 70+yOffset, 50+xOffset, 70+yOffset,1);   
      TV.draw_line( 70+xOffset, 70+yOffset,110+xOffset, 70+yOffset,1);   
      TV.draw_line( 60+xOffset, 70+yOffset, 60+xOffset, 80+yOffset,1);   
      for(int h=5;h<80;h=h+10){
        for(int w=5;w<120;w=w+10){
          TV.set_pixel(w+xOffset,h+yOffset,1);
        }
      }
      TV.draw_rect( 41+xOffset, 31+yOffset,  38,  18, 0, 0);
      TV.draw_circle(  5+xOffset,  5+yOffset,2,1,1);
      TV.draw_circle(115+xOffset,  5+yOffset,2,1,1);
      TV.draw_circle(  5+xOffset, 75+yOffset,2,1,1);
      TV.draw_circle(115+xOffset, 75+yOffset,2,1,1);
    break;
    case 1:
    break;
  }
}
