/*
 * MotorKnob
 *
 * A stepper motor follows the turns of a potentiometer
 * (or other sensor) on analog input 0.
 *
 * http://www.arduino.cc/en/Reference/Stepper
 * This example code is in the public domain.
 */

#include <Stepper.h>

// change this to the number of steps on your motor
#define STEPS 200

// create an instance of the stepper class, specifying
// the number of steps of the motor and the pins it's
// attached to
Stepper stepper(STEPS, 3,4,18,19);

// the previous reading from the analog input
int previous = 0;

void setup()
{
  // set the speed of the motor to 30 RPMs
  pinMode(17, OUTPUT);
  Serial.begin(115200);
}

void loop()
{
  
  // get the sensor value
  int val = map(analogRead(0),0,1023,1,150);
  int vali = digitalRead(10);   // read the input pin
  digitalWrite(17, HIGH);    // sets the LED to the button's value
  Serial.println(vali);
  
  // move a number of steps equal to the change in the
  // sensor reading
  stepper.setSpeed(val);
  stepper.step(10);
  Serial.print("speed: " );
  Serial.println(val);
  digitalWrite(17, LOW);    // sets the LED to the button's value
 
  //Serial.print("Time: ");
  //-unsigned long time = micros();
  //prints time since program started
  //Serial.println(time);
  // wait a second so as not to send massive amounts of data
  //delay(1000);

//delay(250);
  // remember the previous value of the sensor
  //previous = val;
}
